Const ForReading = 1

' Creates an object.
dim dictTable
Set dictTable = CreateObject("Scripting.Dictionary")
' objDictionary.dictTable = vbTextCompare

' Creates an object.
dim dictLast
Set dictLast = CreateObject("Scripting.Dictionary")

dim strdate, strtime
Set objFSO = CreateObject("Scripting.FileSystemObject")

If WScript.Arguments.Count > 0 Then
   Wscript.Echo "Arg0 : " + WScript.Arguments.Item(0)
   strFilter = WScript.Arguments.Item(0) 
end if

dim strOutput
strOutput = "h2_script.sql"
objStartFolder = "."

Set objFolder = objFSO.GetFolder(objStartFolder)

dim sv_File 
sv_File = "ImportFilter.csv"

'' fill filter
  Set objTextFile = objFSO.OpenTextFile(sv_File, ForReading)
  Do Until objTextFile.AtEndOfStream
      strNextLine = objTextFile.Readline
      arrItem = split(strNextLine, "|")
      if Ubound(arrItem) = 2 then
         If not dictTable.Exists(arrItem(0)) then
            dictTable.Add arrItem(0), arrItem(2)
         end if
         If not dictTable.Exists(arrItem(1)) then
            dictTable.Add arrItem(1), arrItem(2)
         end if
      end if
      strPos = instr(strRest,"|")
  Loop
  objTextFile.Close

Wscript.Echo ">>> gefundene Datenpunkte: " & (dictTable.Count/2)

Set objOutFile = objFSO.CreateTextFile(strOutput,True)

' loop over founded files 
Set colFiles = objFolder.Files
For Each objFile in colFiles
    if mid(objFile.Name,1,len(strFilter)) = strFilter Then 

       Wscript.Echo objFile.Name 

       Check_File(objFile.path)
    end if
Next
if IsDate( last_stamp ) Then
   idiff = cdate(strDate + " " + strTime) - last_stamp  
   objOutFile.Write ";" + FormatNumber( idiff,6 ) + vbCrLf
end if 

objOutFile.Close

Wscript.Echo ">>> FileFilter: " + strFilter
Wscript.Echo ">>> Output    : " + strOutput

Wscript.Quit


''****************************
Sub Check_File(sv_File)
  Set objTextFile = objFSO.OpenTextFile(sv_File, ForReading)
  Do Until objTextFile.AtEndOfStream
      strNextLine = objTextFile.Readline
      arrItem = split(strNextLine, " ")
      if Ubound(arrItem) = 2 then
         strDate = mid(strNextLine,1,10)
         strTime = mid(strNextLine,12,8)
         If dictTable.Exists(arrItem(1)) and IsDate(strDate + " " + strTime) Then
            If not dictLast.Exists(arrItem(1)) then
               dictLast.Add arrItem(1), -1
            end if
            if cdate(strDate + " " + strTime) < cdate("2019-01-22 20:37:59") and  dictLast.Item(arrItem(1)) <> arrItem(2) then
               objOutFile.Write  "MERGE INTO " + dictTable.Item(arrItem(1)) + " (TS, VALUE, STATE) key(TS) VALUES (TIMESTAMP '"+strDate+" "+strTime+".000', " + arrItem(2) +", 0);" + vbCrLf

               dictLast.Remove arrItem(1)
               dictLast.Add arrItem(1), arrItem(2)
            end if
         end if
      end if      
  Loop
  objTextFile.Close
End Sub
